import { h, Component } from 'preact';
import { Router, route } from 'preact-router';
import WBBrowse from 'wb-browse';
import WBSignIn from 'wb-sign-in';
import WBLandingPage from 'wb-landing-page';

class WBApp extends Component {
  constructor(...args) {
    super(...args);
    this.state.arvHost = window.localStorage['arvHost'];
    this.state.arvToken = window.localStorage['arvToken'];
    this.state.currentUser = JSON.parse(window.localStorage['currentUser']);
    this.appCallbacks = {
      'navbarItemClicked': item => this.navbarItemClicked(item)
    };
    this.appState = {
      'arvHost': this.state.arvHost,
      'arvToken': this.state.arvToken,
      'currentUser': this.state.currentUser
    };
  }

  navbarItemClicked(item) {
    if (item['id'] === 'sign-out') {
      delete window.localStorage['arvHost'];
      delete window.localStorage['arvToken'];
      delete window.localStorage['currentUser'];
      route('/sign-in');

    } else if (item['id'] === 'home') {
      route('/browse/' + this.appState.currentUser.uuid);

    } else if (item['id'] === 'all-projects') {
      route('/browse');

    }
  }

  render() {
    return (
      <Router>
        <WBLandingPage path="/" />

        <WBSignIn path="/sign-in" appState={ this.appState } />

        <WBBrowse path="/browse/:ownerUuid?/:activePage?"
          appCallbacks={ this.appCallbacks }
          appState={ this.appState } />
      </Router>
    );
  }
}

export default WBApp;
